# 第二部分：简单的黑魔法

你有最好的想法，你会打动世界！你会成为一个亿万富豪！你的大脑与这个概念融为一体，你会在你的梦想中看到它，它像幽灵一样困扰着你。下一步就是实现它，将其从大脑中移出并放进计算机。你必须杀死鬼魂，将幽灵从灵魂世界中带出来，将其绑定到一个 Python 图腾上，并将其扔到互联网的海洋中。

对你而言足够有创意嘛？

创造力的敌人就是起步。如果在安装程序的过程中存在障碍，你怎么能实现你的梦想？如果你的想法非常强烈和庞大，让你开始担心呢？你足够好吗？你足够聪明吗？那个著名的程序员，会首先让你写出测试，否则会由于你不知道该怎么做而生气嘛？入门通常是创造力中最困难的事情之一，这本书的这部分旨在让你渡过它。

我是画家，音乐家，作家和程序员，所以我知道一两件关于创意的事情。我更了解入门和流程。当我对处理某个项目不感兴趣的时候，流程是将我拖出项目的泥泞的东西。但是，如果没有首先的起步，我就不能走到这一步。

起步需要勇气，并且对任何人的想法有些不关心。在绘画中，当我不能开始时，我只是随意抓取颜料，并在画布上砸在正确的位置。很多非常成功的画家都是这样工作的。其他画家从头开始研究 - 学习，测试，素描，然后最终将它们全部放到一起来开始。作为一个作家，我所做的第一件事就是在我的房子周围散步，疯狂地和自己说话，想像我正在和某人交谈，然后当我说出足够的说话时，我坐下来写作。我只是写下了出现在我脑子里的第一件事。

我不会坐下来写作，或者担心语法。我不会问，“我很聪明吗？”我只是写出我如何说话，并将其输入键盘，然后当我完成了几个段落，我会看一看。它是否有意义？我需要清理吗？这样的确有效，并让我继续下去。也许我写的是垃圾。但是，我开始了，并且这个很重要。之后，我依靠我的流程把起始点变成一个完整的词。

你如何看待这个创造性的起步？我的朋友，你需要弄清楚，并且这本书会有所帮助。首先我们需要打破你对这个起步的恐惧。也许甚至不再害怕了。也许在你开始编程之前，你需要做大量无意义的事情，这样你才能够溢出所有障碍。

我在第一部分说过，如果你每次去做一件事的时候，你必须清理一小时，并修复一堆工具，你就不会有创造力。

## 如何实践创造力

在这本书的这一部分，你将通过让自己立即开始，快速实践创造力。我会给你简单的超级无聊的小项目。我的意思是，Unix 的`cat`命令只是输出一个文件。老实说就像两行 Python 一样简单。这些项目的起步是重要的，为了起步，你会变得冷酷无情。你要坐在你的电脑旁边，纵身已阅，让事情发生。就是现在，不是30分钟后。

你怎么做到他呢？您需要一个清单，您需要自动化。清单是您必须准备好去做的所有事情。打开你的电脑，关掉社交媒体，启动你的编辑器，摸一摸你的幸运的橡皮小鸭，做一个神圣的祷告，冥想 10 分钟，然后复制你的项目框架并开始。这是一个例子，但你需要一个检查列表，并且越短越好。

但你不知道这个清单是什么。也许你有一个想法，但你在开始工作之前真的知道你所做的一切吗？这就是每个项目中，您将重点关注的东西。在第一个项目中，你会坐下来尝试一下，但你会记下你所做的一切。你不能管理无法测量的东西，这是衡量自己的第一步，来看看你如何做某件事情。如果您有屏幕录制软件会更好。打开它，并记录你自己写出了一个糟糕的软件，然后观看视频。记下你做了什么

为了确保您不要在项目中埋头骨干，而是练习起步，您还将为每个项目设置一个严格的计时器。你必须在45分钟内完成最棒的垃圾。不多不少。开始时设置一个45分钟的定时器，准备好你的本子和铅笔，然后去做吧。当定时器关闭时，你完成了。看看你做了什么，然后好的那部分才会出现。

每个项目后，拿起您的列表，并找出可以做什么来消除障碍。你坐在那里，做许多小文件，并且必须在互联网上查找嘛？制作项目框架吧。您在文本编辑器中输入命令时似乎有问题吗？花时间学习来更好地使用它，或学习盲打。你不知道基本的命令和 API 吗？去获取一些书来学习吧，我的朋友。

然后删掉代码并重新开始。从头开始。使用新的纸张开始写，或开始录制。无论你需要做什么来跟踪你所做的事情。这次你更进一步了嘛？有更少的障碍吗？你的目标是减少想法和实现之间的时间，直到起步只是你做的意见事情，就像吃饭和呼吸那样，最终你会感觉到起步是自然的，之后你可以继续下一个项目。

请记住，你要立即坐下来并编程。尽管去做吧。如果一个内心的声音告诉你，你这样做错了，就告诉那个愚蠢的声音来让它闭嘴。这才是 Hack。保持放松并全力以赴，就像你只是把代码扔给一个朋友，它知道你是傻瓜但仍然很有趣。像测试和质量这样的愚蠢的事情可能会在本书的后面出现，但现在只需要编程，把东西搞乱，实现一些黑魔法。获得想法比赢得虚构的质量比赛更重要。

在每个仓促的 45 分钟 Hack 之后，你坐下来查看你是怎么做的。这个“创造然后批改”的过程，将来可以帮助你改善。
